Subject: Re: bug#21832: 11.88.8; prompt for using LuaTeX/XeTeX engine

From: Mosè Giordano <[email-masked]>
Date: Thu, 5 Nov 2015 00:01:27 +0100

2015-11-04 23:50 GMT+01:00 jfbu <[email-masked]>:
>> Do you have other suggestions?  They're welcome :-)
>
>
> I don't at this time ... I was surprised by the prompt
> for XeTeX/LuaTeX (which in my use case was wrong, but
> certainly that was very specific context), and if I had
> to pause to think about it, I would be tempted by the somewhat
> provocative but sincere feeling that checking for the
> engine is not that of a good idea. It would perhaps
> if only *one* engine was proposed as candidate

fontspec requires two engines, we can't select one of the two for the
user.  The point is that compilation will certainly fail if one loads
particular packages, provided that there aren't conditionals.  A
prompt suggesting you the action to take is better than waiting for
the compilation to finish and then try to realize what went wrong.

> but if one has
> to choose between luatex and xetex, that's not much
> speed gain compared to doing it beforehand, or
> being confronted with a botched pdflatex compilation and
> doing it then.
>
> Recently I read a bit of XeTeX doc, and it is perfectly
> possible to use it without fontspec package.

Indeed the problem is the other way round: you can't use fontspec
without {Xe,Lua}TeX.

> I find it a bit surprising to tie discovery of XeTeX/LuateX
> to use of fontspec package.
>
> Why not rather a file variable at top of file ? Yes, user will
> have thus to put something explicit there, but isn't it actually
> better if the file is destined to be exchanged with other people
> possibly not using Emacs/AUCTeX ?

We already have a file-local variable to specify the engine to use,
`TeX-engine', the check is only for those who forget to set it
properly.

Cheers,
Mosè